import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { UserCard, UserCardParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询会员卡
 */
export async function pageUserCard(params: UserCardParam) {
  const res = await request.get<ApiResult<PageResult<UserCard>>>(
    MODULES_API_URL + '/booking/user-card/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询会员卡列表
 */
export async function listUserCard(params?: UserCardParam) {
  const res = await request.get<ApiResult<UserCard[]>>(
    MODULES_API_URL + '/booking/user-card',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加会员卡
 */
export async function addUserCard(data: UserCard) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/user-card',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改会员卡
 */
export async function updateUserCard(data: UserCard) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/user-card',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除会员卡
 */
export async function removeUserCard(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/user-card/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除会员卡
 */
export async function removeBatchUserCard(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/user-card/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询会员卡
 */
export async function getUserCard(id: number) {
  const res = await request.get<ApiResult<UserCard>>(
    MODULES_API_URL + '/booking/user-card/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
